unit CapTest1a;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CaptionControl, ExtCtrls, StdCtrls, ComCtrls;

type
  TCaptionTest = class(TForm)
    CaptionControl: TCaptionControl;
    Timer: TTimer;
    GradGroup: TRadioGroup;
    BtnGroup: TRadioGroup;
    ShowBtn: TCheckBox;
    EventsLbl: TLabel;
    EventsList: TListBox;
    procedure CaptionControlDrawCaption(Sender: TObject;
      var CaptionText: string; DC: Integer; Rect: TRect;
      var Drawn: Boolean);
    procedure TimerTimer(Sender: TObject);
    procedure ShowBtnClick(Sender: TObject);
    procedure BtnGroupClick(Sender: TObject);
    procedure GradGroupClick(Sender: TObject);
    procedure CaptionControlButtonClick(Sender: TObject;
      ButtonIndex: Integer; var Pushed: Boolean);
  private
    { Private declarations }
    LabelOffset: Integer;
  public
    { Public declarations }
  end;

var
  CaptionTest: TCaptionTest;

implementation

{$R *.DFM}

procedure TCaptionTest.CaptionControlDrawCaption(Sender: TObject;
  var CaptionText: string; DC: Integer; Rect: TRect; var Drawn: Boolean);
begin
  DrawTextEx(DC, PChar(CaptionText),
    -1, Rect, DT_LEFT or DT_SINGLELINE or DT_VCENTER, nil);
  Dec(Rect.Right, LabelOffset);
  DrawTextEx(DC, 'testing...',
    -1, Rect, DT_RIGHT or DT_SINGLELINE or DT_VCENTER, nil);
  Drawn := True;
end;

procedure TCaptionTest.TimerTimer(Sender: TObject);
begin
  Inc(LabelOffset, 3);
  if LabelOffset>ClientWidth then LabelOffset := 0;
  CaptionControl.Refresh;
end;

procedure TCaptionTest.ShowBtnClick(Sender: TObject);
begin
  CaptionControl.ShowButtons := ShowBtn.Checked;
end;

procedure TCaptionTest.BtnGroupClick(Sender: TObject);
begin
  if BtnGroup.ItemIndex=0 then
    CaptionControl.ButtonsDirection := dirLeft else
    CaptionControl.ButtonsDirection := dirRight;
end;

procedure TCaptionTest.GradGroupClick(Sender: TObject);
begin
  with CaptionControl do
    case GradGroup.ItemIndex of
      0: CaptionGradient := cgNone;
      1: CaptionGradient := cgActive;
      2: CaptionGradient := cgAlways;
    end;
end;

procedure TCaptionTest.CaptionControlButtonClick(Sender: TObject;
  ButtonIndex: Integer; var Pushed: Boolean);
begin
  EventsList.Items.Add('Click button '+IntToStr(ButtonIndex));
end;

end.
